﻿using System;
using System.Collections.Generic;

namespace CornerCases
{
    static class LinqWhereFixed
    {
        static IEnumerable<T> Where<T>(
            this IEnumerable<T> source,
            Func<T, bool> predicate)
        {
            if (source == null)
            {
                throw new ArgumentNullException("source");
            }
            return WhereImpl(source, predicate);
        }

        static IEnumerable<T> WhereImpl<T>(
            IEnumerable<T> source,
            Func<T, bool> predicate)
        {
            foreach (T item in source)
            {
                if (predicate(item))
                {
                    yield return item;
                }
            }
        }

        static void Main()
        {
            string[] strings = null;
            var longStrings = strings.Where(x => x.Length > 10);
            Console.WriteLine("Press return to see the long strings");
            Console.ReadLine();
            foreach (string x in longStrings)
            {
                Console.WriteLine(x);
            }
        }
    }
}
