﻿using System;
using System.Threading.Tasks;
using System.Threading;

namespace CornerCases
{
    class ParallelLoopFixed
    {
        static void Main()
        {
            string[] urls = { "foo.com", "bar.com", "baz.com",
                              "a", "b", "c", "d", "e" };

            foreach (string url in urls)
            {
                string urlCopy = url;
                new Thread(() => Fetch(urlCopy)).Start();
            }
            Thread.Sleep(1000);

            // But rather better...
            Parallel.ForEach(urls, url => Fetch(url));

            // Alternatively:
            Parallel.ForEach(urls, Fetch);

            // Alternatively
            Parallel.ForEach(urls, url => {
                // Do stuff here
            });
        }

        static void Fetch(string url)
        {
            Console.WriteLine("Fetching {0}", url);
        }
    }
}
