﻿using System;
using System.Runtime.CompilerServices;

namespace CornerCases
{
    class SingletonTiming
    {
        sealed class Singleton
        {
            // static Singleton() { }

            private static readonly Singleton instance = new Singleton();

            [MethodImpl(MethodImplOptions.NoInlining)]
            internal static Singleton GetInstance() { return instance; }

            private Singleton()
            {
                Console.WriteLine("Creating singleton");
            }

            internal static void DummyMethod()
            {
                Console.WriteLine("Dummy singleton method");
            }
        }

        static void Main(string[] args)
        {
            Console.WriteLine("Start");
            Singleton.DummyMethod();
            Console.WriteLine("Middle");            
            Singleton.GetInstance();
            Console.WriteLine("After");
        }
    }
}
