﻿using System;
using System.Text;

namespace CornerCases
{
    class SurpriseBoxing    
    {
        static void Show<T>() where T : new()
        {
            Console.WriteLine("Details for {0}", typeof(T).Name);
            T value = new T();
            Console.WriteLine("Hash code: {0}", value.GetHashCode());
            Console.WriteLine("Value is null: {0}", value == null);
            Console.WriteLine("Equality is reflexive: {0}", value.Equals(value));
            Console.WriteLine("ToString: {0}", value.ToString());
            Console.WriteLine("GetType: {0}", value.GetType());
            Console.WriteLine();
        }

        static void Main()
        {
            Show<int>();
            Show<StringBuilder>();
            Show<Guid>();
            Show<int?>();
        }
    }
}
